/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_MBOX
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_mbox.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"

static int
do_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

static void
close_mbox(struct mf_mbox *mp)
{
	if (mp->mbox) {
		mu_mailbox_close(mp->mbox);
		mu_mailbox_destroy(&mp->mbox);
		mu_list_do(mp->msglist, do_close, NULL);
		mu_list_destroy(&mp->msglist);
		memset(mp, 0, sizeof mp[0]);
	}
}

static void *
alloc_mboxes()
{
	return xcalloc(NMBOXES, sizeof(struct mf_mbox));
}

static void
destroy_mboxes(void *data)
{
	struct mf_mbox *mtab = data;
	struct mf_mbox *p;
	for (p = mtab; p < mtab + NMBOXES; p++) {
		close_mbox(p);
	}
	free(mtab);
}


#line 55

#line 55
static int MBOXTAB_id;
#line 55 "bi_mbox.m4"


static int
find_slot(struct mf_mbox *tab)
{
	int i;
	for (i = 0; i < NMBOXES; i++)
		if (tab[i].mbox == NULL)
			return i;
	return -1;
}

/* number mailbox_open(string url) */
void
#line 68
bi_mailbox_open(eval_environ_t env)
#line 68

#line 68 "bi_mbox.m4"
{
#line 68
	
#line 68

#line 68
long __bi_argcnt;
#line 68
char * url;
#line 68
        char * mode;
#line 68
        char * perms;
#line 68
        
#line 68
get_string_arg(env, 1, &url);
#line 68
        get_string_arg(env, 2, &mode);
#line 68
        get_string_arg(env, 3, &perms);
#line 68
        
#line 68
get_numeric_arg(env, 0, &__bi_argcnt);
#line 68
        adjust_stack(env, __bi_argcnt + 1);
#line 68

#line 68
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 68
		prog_trace(env, "mailbox_open %s %s %s",url, ((__bi_argcnt > 1) ? mode : ""), ((__bi_argcnt > 2) ? perms : ""));;
#line 68

{
	int rc;
	int md;
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
	struct mf_mbox *mp;
	int flags;
	char *p;

	md = find_slot(mbtab);
		if (!(md >= 0))
#line 78
			env_throw_bi(env, mfe_failure, "mailbox_open", _("No more mailboxes available"))
#line 80
;
	debug1(10, "opening mailbox %s", url);
	mp = mbtab + md;

	flags = 0;
	for (p = ((__bi_argcnt > 1) ? mode : "r"); *p; p++) {
		switch (*p) {
		case 'a':
			flags |= MU_STREAM_APPEND;
			break;
			
		case 'r':
			flags |= MU_STREAM_READ;
			break;
			
		case 'w':
			flags |= MU_STREAM_WRITE;
			break;
			
		case '+':
			if (flags & MU_STREAM_READ)
				flags |= MU_STREAM_WRITE;
			else if (flags & MU_STREAM_WRITE)
				/* FIXME: should truncate as well */
				flags |= MU_STREAM_READ|MU_STREAM_CREAT;
			else if (flags & MU_STREAM_APPEND) {
				flags |= MU_STREAM_RDWR | MU_STREAM_CREAT;
			} else
					env_throw_bi(env, mfe_range, "mailbox_open", _("Incorrect mode near `%s'"),p);
#line 111
			break;

		default:
				env_throw_bi(env, mfe_range, "mailbox_open", _("Incorrect mode near `%s'"),p);
#line 117
		}
	}

	if ((__bi_argcnt > 2)) {
		/* If MU_STREAM_IRGRP is defined, the remaining three
		   permissions flags are defined as well.
		   FIXME: Remove ifdef when MU 2.0 is out. */
#ifdef MU_STREAM_IRGRP
		int f;
		const char *p;
			if (!(mu_parse_stream_perm_string(&f, ((__bi_argcnt > 1) ? mode : 0), &p)
#line 127
			  == 0))
#line 127
			env_throw_bi(env, mfe_range, "mailbox_open", /* FIXME: introduce mfe_inval? */
			  _("invalid permissions (near %s)"),p)
#line 130
;
		flags |= f;
#else
			env_throw_bi(env, mfe_failure, "mailbox_open", _("This version of Mailutils does not support "
			   "configurable mailbox permissions"));
#line 136
#endif
	}
		
	rc = mu_mailbox_create(&mp->mbox, url);
		if (!(rc == 0))
#line 140
			env_throw_bi(env, mfe_failure, "mailbox_open", _("Cannot create mailbox `%s': %s"),url,mu_strerror(rc))
#line 143
;
	rc = mu_mailbox_open(mp->mbox, flags);
	if (rc) {
		mu_mailbox_destroy(&mp->mbox);
			env_throw_bi(env, mfe_failure, "mailbox_open", _("Cannot open mailbox `%s': %s"),url,mu_strerror(rc));
#line 150
	}
	mu_list_create(&mp->msglist);
	
	
#line 153
do {
#line 153
  push(env, (STKVAL) (md));
#line 153
  return;
#line 153
} while (0);
}
}

/* void mailbox_close(number mbx) */
void
#line 158
bi_mailbox_close(eval_environ_t env)
#line 158

#line 158 "bi_mbox.m4"
{
#line 158
	
#line 158

#line 158

#line 158
long  md;
#line 158
        
#line 158
get_numeric_arg(env, 0, &md);
#line 158
        
#line 158

#line 158
        adjust_stack(env, 1);
#line 158

#line 158
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 158
		prog_trace(env, "mailbox_close %lu",md);;
#line 158

{
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);

		if (!(md >= 0 && md < NMBOXES))
#line 162
			env_throw_bi(env, mfe_range, "mailbox_close", _("Invalid mailbox descriptor"))
#line 164
;
	close_mbox(mbtab + md);
}
}

#line 180

	
/* number mailbox_messages_count(number mbx) */
void
#line 183
bi_mailbox_messages_count(eval_environ_t env)
#line 183

#line 183 "bi_mbox.m4"
{
#line 183
	
#line 183

#line 183

#line 183
long  nmbx;
#line 183
        
#line 183
get_numeric_arg(env, 0, &nmbx);
#line 183
        
#line 183

#line 183
        adjust_stack(env, 1);
#line 183

#line 183
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 183
		prog_trace(env, "mailbox_messages_count %lu",nmbx);;
#line 183

{
	size_t count;
	int rc;
	
#line 187
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 187
	struct mf_mbox *mp;
#line 187
			
#line 187
		if (!(nmbx >= 0 && nmbx < NMBOXES))
#line 187
			env_throw_bi(env, mfe_range, "mailbox_messages_count", _("Invalid mailbox descriptor"))
#line 187
;
#line 187
	mp = mbtab + nmbx;
#line 187
		if (!(mp->mbox))
#line 187
			env_throw_bi(env, mfe_failure, "mailbox_messages_count", _("Mailbox not open"))
#line 187

#line 187
;
	
	rc = mu_mailbox_messages_count(mp->mbox, &count);
		if (!(rc == 0))
#line 190
			env_throw_bi(env, mfe_failure, "mailbox_messages_count", "%s",mu_strerror(rc))
#line 193
;
	
#line 194
do {
#line 194
  push(env, (STKVAL) (count));
#line 194
  return;
#line 194
} while (0);
}
}

/* number mailbox_get_message(number mbx, number msg-no) */
void
#line 199
bi_mailbox_get_message(eval_environ_t env)
#line 199

#line 199 "bi_mbox.m4"
{
#line 199
	
#line 199

#line 199

#line 199
long  nmbx;
#line 199
        long  msgno;
#line 199
        
#line 199
get_numeric_arg(env, 0, &nmbx);
#line 199
        get_numeric_arg(env, 1, &msgno);
#line 199
        
#line 199

#line 199
        adjust_stack(env, 2);
#line 199

#line 199
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 199
		prog_trace(env, "mailbox_get_message %lu %lu",nmbx, msgno);;
#line 199

{
	int rc;
	mu_message_t msg;
	
#line 203
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 203
	struct mf_mbox *mp;
#line 203
			
#line 203
		if (!(nmbx >= 0 && nmbx < NMBOXES))
#line 203
			env_throw_bi(env, mfe_range, "mailbox_get_message", _("Invalid mailbox descriptor"))
#line 203
;
#line 203
	mp = mbtab + nmbx;
#line 203
		if (!(mp->mbox))
#line 203
			env_throw_bi(env, mfe_failure, "mailbox_get_message", _("Mailbox not open"))
#line 203

#line 203
;

	rc = mu_mailbox_get_message(mp->mbox, msgno, &msg);
		if (!(rc == 0))
#line 206
			env_throw_bi(env, mfe_failure, "mailbox_get_message", "%s",mu_strerror(rc))
#line 209
;
	rc = bi_message_register(env, mp->msglist, msg, 0);
		if (!(rc >= 0))
#line 211
			env_throw_bi(env, mfe_failure, "mailbox_get_message", _("No more message slots available"))
#line 213
;
	
#line 214
do {
#line 214
  push(env, (STKVAL) (rc));
#line 214
  return;
#line 214
} while (0);
}
}

/* void mailbox_append_message(number mbx, number msg-no) */
void
#line 219
bi_mailbox_append_message(eval_environ_t env)
#line 219

#line 219 "bi_mbox.m4"
{
#line 219
	
#line 219

#line 219

#line 219
long  nmbx;
#line 219
        long  msgno;
#line 219
        
#line 219
get_numeric_arg(env, 0, &nmbx);
#line 219
        get_numeric_arg(env, 1, &msgno);
#line 219
        
#line 219

#line 219
        adjust_stack(env, 2);
#line 219

#line 219
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 219
		prog_trace(env, "mailbox_append_message %lu %lu",nmbx, msgno);;
#line 219

{
	int rc;
	mu_message_t msg;
	
#line 223
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 223
	struct mf_mbox *mp;
#line 223
			
#line 223
		if (!(nmbx >= 0 && nmbx < NMBOXES))
#line 223
			env_throw_bi(env, mfe_range, "mailbox_append_message", _("Invalid mailbox descriptor"))
#line 223
;
#line 223
	mp = mbtab + nmbx;
#line 223
		if (!(mp->mbox))
#line 223
			env_throw_bi(env, mfe_failure, "mailbox_append_message", _("Mailbox not open"))
#line 223

#line 223
;

	msg = bi_message_from_descr(env, msgno);
	rc = mu_mailbox_append_message(mp->mbox, msg);
		if (!(rc == 0))
#line 227
			env_throw_bi(env, mfe_failure, "mailbox_append_message", _("Cannot append message: %s"),mu_strerror(rc))
#line 230
;
}
}


#line 234
void
#line 234
mbox_init_builtin()
#line 234
{
#line 234
	#line 55 "bi_mbox.m4"
MBOXTAB_id = builtin_priv_register(alloc_mboxes, destroy_mboxes);
#line 68 "bi_mbox.m4"
va_builtin_install_ex("mailbox_open", bi_mailbox_open, 0, dtype_number, 3, 2, 0|0, dtype_string, dtype_string, dtype_string);
#line 158 "bi_mbox.m4"
va_builtin_install_ex("mailbox_close", bi_mailbox_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 183 "bi_mbox.m4"
va_builtin_install_ex("mailbox_messages_count", bi_mailbox_messages_count, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 199 "bi_mbox.m4"
va_builtin_install_ex("mailbox_get_message", bi_mailbox_get_message, 0, dtype_number, 2, 0, 0|0, dtype_number, dtype_number);
#line 219 "bi_mbox.m4"
va_builtin_install_ex("mailbox_append_message", bi_mailbox_append_message, 0, dtype_unspecified, 2, 0, 0|0, dtype_number, dtype_number);

#line 234 "bi_mbox.m4"
		
#line 234
}
#line 603 "../mfd/snarf.m4"

#line 603

